import Foundation
import Phidget22_C

public enum EncoderIOMode: UInt32 {
	case pushPull = 1
	case lineDriver_2K2 = 2
	case lineDriver_10K = 3
	case openCollector_2K2 = 4
	case openCollector_10K = 5
}
public enum ErrorCode: UInt32 {
	case success = 0
	case notPermitted = 1
	case noSuchEntity = 2
	case timeout = 3
	case keepAlive = 58
	case interrupted = 4
	case IO = 5
	case noMemory = 6
	case access = 7
	case fault = 8
	case busy = 9
	case exists = 10
	case isNotDirectory = 11
	case isDirectory = 12
	case invalid = 13
	case tooManyFilesSystem = 14
	case tooManyFiles = 15
	case noSpace = 16
	case fileTooBig = 17
	case readOnlyFilesystem = 18
	case readOnly = 19
	case unsupported = 20
	case invalidArgument = 21
	case tryAgain = 22
	case notEmpty = 26
	case unexpected = 28
	case duplicate = 27
	case badPassword = 37
	case networkUnavailable = 45
	case connectionRefused = 35
	case connectionReset = 46
	case hostUnreachable = 48
	case noSuchDevice = 40
	case wrongDevice = 50
	case brokenPipe = 41
	case nameResolutionFailure = 44
	case unknownValue = 51
	case notAttached = 52
	case invalidPacket = 53
	case tooBig = 54
	case badVersion = 55
	case closed = 56
	case notConfigured = 57
	case endOfFile = 31
}
public enum ErrorEventCode: UInt32 {
	case badVersion = 1
	case busy = 2
	case network = 3
	case dispatch = 4
	case success = 4096
	case overrun = 4098
	case packetLost = 4099
	case wrapAround = 4100
	case overTemperature = 4101
	case overCurrent = 4102
	case outOfRange = 4103
	case badPower = 4104
	case saturation = 4105
	case overVoltage = 4107
	case failsafeCondition = 4108
	case voltageError = 4109
	case energyDumpCondition = 4110
	case motorStallCondition = 4111
}
public enum DeviceID: UInt32 {
	case none = 0
	case PN_interfaceKit488 = 1
	case PN_1000 = 2
	case PN_1001 = 3
	case PN_1002 = 4
	case PN_1008 = 5
	case PN_1010_1013_1018_1019 = 6
	case PN_1011 = 7
	case PN_1012 = 8
	case PN_1014 = 9
	case PN_1015 = 10
	case PN_1016 = 11
	case PN_1017 = 12
	case PN_1023 = 13
	case PN_1024 = 14
	case PN_1030 = 15
	case PN_1031 = 16
	case PN_1032 = 17
	case PN_1040 = 18
	case PN_1041 = 19
	case PN_1042 = 20
	case PN_1043 = 21
	case PN_1044 = 22
	case PN_1045 = 23
	case PN_1046 = 24
	case PN_1047 = 25
	case PN_1048 = 26
	case PN_1049 = 27
	case PN_1051 = 28
	case PN_1052 = 29
	case PN_1053 = 30
	case PN_1054 = 31
	case PN_1055 = 32
	case PN_1056 = 33
	case PN_1057 = 34
	case PN_1058 = 35
	case PN_1059 = 36
	case PN_1060 = 37
	case PN_1061 = 38
	case PN_1062 = 39
	case PN_1063 = 40
	case PN_1064 = 41
	case PN_1065 = 42
	case PN_1066 = 43
	case PN_1067 = 44
	case PN_1202_1203 = 45
	case PN_1204 = 46
	case PN_1215__1218 = 47
	case PN_1219__1222 = 48
	case PN_ADP1000 = 49
	case PN_DAQ1000 = 51
	case PN_DAQ1200 = 52
	case PN_DAQ1300 = 53
	case PN_DAQ1301 = 54
	case PN_DAQ1400 = 55
	case PN_DAQ1500 = 56
	case PN_DCC1000 = 57
	case PN_DST1200 = 59
	case PN_ENC1000 = 60
	case PN_HIN1000 = 61
	case PN_HIN1001 = 62
	case PN_HIN1100 = 63
	case PN_HUB0000 = 64
	case PN_HUB0004 = 67
	case PN_HUM1000 = 69
	case PN_LED1000 = 71
	case PN_LUX1000 = 72
	case PN_OUT1000 = 75
	case PN_OUT1001 = 76
	case PN_OUT1002 = 77
	case PN_OUT1100 = 78
	case PN_PRE1000 = 79
	case PN_RCC1000 = 80
	case PN_REL1000 = 81
	case PN_REL1100 = 82
	case PN_REL1101 = 83
	case PN_SAF1000 = 84
	case PN_SND1000 = 85
	case PN_STC1000 = 86
	case PN_TMP1000 = 87
	case PN_TMP1100 = 88
	case PN_TMP1101 = 89
	case PN_TMP1200 = 90
	case PN_VCP1000 = 92
	case PN_VCP1001 = 93
	case PN_VCP1002 = 94
	case digitalInputPort = 95
	case digitalOutputPort = 96
	case voltageInputPort = 97
	case voltageRatioInputPort = 98
	case PN_DCC1100 = 108
	case PN_HIN1101 = 109
	case PN_DICTIONARY = 111
}
public enum LogLevel: UInt32 {
	case critical = 1
	case error = 2
	case warning = 3
	case info = 4
	case debug = 5
	case verbose = 6
}
public enum DeviceClass: UInt32 {
	case accelerometer = 1
	case advancedServo = 2
	case analog = 3
	case bridge = 4
	case encoder = 5
	case frequencyCounter = 6
	case GPS = 7
	case hub = 8
	case interfaceKit = 9
	case IR = 10
	case LED = 11
	case meshDongle = 12
	case motorControl = 13
	case PHSensor = 14
	case RFID = 15
	case servo = 16
	case spatial = 17
	case stepper = 18
	case temperatureSensor = 19
	case textLCD = 20
	case VINT = 21
	case dictionary = 24
}
public enum ChannelClass: UInt32 {
	case accelerometer = 1
	case currentInput = 2
	case dataAdapter = 3
	case DCMotor = 4
	case digitalInput = 5
	case digitalOutput = 6
	case distanceSensor = 7
	case encoder = 8
	case frequencyCounter = 9
	case GPS = 10
	case LCD = 11
	case gyroscope = 12
	case hub = 13
	case capacitiveTouch = 14
	case humiditySensor = 15
	case IR = 16
	case lightSensor = 17
	case magnetometer = 18
	case meshDongle = 19
	case PHSensor = 37
	case powerGuard = 20
	case pressureSensor = 21
	case RCServo = 22
	case resistanceInput = 23
	case RFID = 24
	case soundSensor = 25
	case spatial = 26
	case stepper = 27
	case temperatureSensor = 28
	case voltageInput = 29
	case voltageOutput = 30
	case voltageRatioInput = 31
	case motorPositionController = 34
	case BLDCMotor = 35
	case dictionary = 36
}
public enum ChannelSubclass: UInt32 {
	case none = 1
	case digitalOutputDutyCycle = 16
	case digitalOutputLEDDriver = 17
	case temperatureSensorRTD = 32
	case temperatureSensorThermocouple = 33
	case voltageInputSensorPort = 48
	case voltageRatioInputSensorPort = 64
	case voltageRatioInputBridge = 65
	case LCDGraphic = 80
	case LCDText = 81
	case encoderModeSettable = 96
	case RCServoEmbedded = 112
}
public enum MeshMode: UInt32 {
	case router = 1
	case sleepyEndDevice = 2
}
public enum PowerSupply: UInt32 {
	case off = 1
	case volts_12 = 2
	case volts_24 = 3
}
public enum RTDWireSetup: UInt32 {
	case wires_2 = 1
	case wires_3 = 2
	case wires_4 = 3
}
public enum InputMode: UInt32 {
	case NPN = 1
	case PNP = 2
}
public enum FanMode: UInt32 {
	case off = 1
	case on = 2
	case auto = 3
}
public enum Unit: UInt32 {
	case none = 0
	case boolean = 1
	case percent = 2
	case decibel = 3
	case millimeter = 4
	case centimeter = 5
	case meter = 6
	case gram = 7
	case kilogram = 8
	case milliampere = 9
	case ampere = 10
	case kilopascal = 11
	case volt = 12
	case degreeCelcius = 13
	case lux = 14
	case gauss = 15
	case pH = 16
	case watt = 17
}
public enum LEDForwardVoltage: UInt32 {
	case volts_1_7 = 1
	case volts_2_75 = 2
	case volts_3_2 = 3
	case volts_3_9 = 4
	case volts_4_0 = 5
	case volts_4_8 = 6
	case volts_5_0 = 7
	case volts_5_6 = 8
}
public enum FrequencyFilterType: UInt32 {
	case zeroCrossing = 1
	case logicLevel = 2
}
public struct GPSTime {
	public var millisecond: Int16
	public var second: Int16
	public var minute: Int16
	public var hour: Int16

	public init(
		millisecond: Int16,
		second: Int16,
		minute: Int16,
		hour: Int16
	) {
		self.millisecond = millisecond
		self.second = second
		self.minute = minute
		self.hour = hour
	}

	internal init(_ cstruct: Phidget22_C.PhidgetGPS_Time) {
		millisecond = cstruct.tm_ms
		second = cstruct.tm_sec
		minute = cstruct.tm_min
		hour = cstruct.tm_hour
	}
	internal var cstruct: Phidget22_C.PhidgetGPS_Time {
		get {
			var cstruct: Phidget22_C.PhidgetGPS_Time = Phidget22_C.PhidgetGPS_Time()
			cstruct.tm_ms = Int16(millisecond)
			cstruct.tm_sec = Int16(second)
			cstruct.tm_min = Int16(minute)
			cstruct.tm_hour = Int16(hour)
			return cstruct
		}
	}
}
public struct GPSDate {
	public var day: Int16
	public var month: Int16
	public var year: Int16

	public init(
		day: Int16,
		month: Int16,
		year: Int16
	) {
		self.day = day
		self.month = month
		self.year = year
	}

	internal init(_ cstruct: Phidget22_C.PhidgetGPS_Date) {
		day = cstruct.tm_mday
		month = cstruct.tm_mon
		year = cstruct.tm_year
	}
	internal var cstruct: Phidget22_C.PhidgetGPS_Date {
		get {
			var cstruct: Phidget22_C.PhidgetGPS_Date = Phidget22_C.PhidgetGPS_Date()
			cstruct.tm_mday = Int16(day)
			cstruct.tm_mon = Int16(month)
			cstruct.tm_year = Int16(year)
			return cstruct
		}
	}
}
public struct GPGGA {
	public var latitude: Double
	public var longitude: Double
	public var fixQuality: Int16
	public var numSatellites: Int16
	public var horizontalDilution: Double
	public var altitude: Double
	public var heightOfGeoid: Double

	public init(
		latitude: Double,
		longitude: Double,
		fixQuality: Int16,
		numSatellites: Int16,
		horizontalDilution: Double,
		altitude: Double,
		heightOfGeoid: Double
	) {
		self.latitude = latitude
		self.longitude = longitude
		self.fixQuality = fixQuality
		self.numSatellites = numSatellites
		self.horizontalDilution = horizontalDilution
		self.altitude = altitude
		self.heightOfGeoid = heightOfGeoid
	}

	internal init(_ cstruct: Phidget22_C.PhidgetGPS_GPGGA) {
		latitude = cstruct.latitude
		longitude = cstruct.longitude
		fixQuality = cstruct.fixQuality
		numSatellites = cstruct.numSatellites
		horizontalDilution = cstruct.horizontalDilution
		altitude = cstruct.altitude
		heightOfGeoid = cstruct.heightOfGeoid
	}
	internal var cstruct: Phidget22_C.PhidgetGPS_GPGGA {
		get {
			var cstruct: Phidget22_C.PhidgetGPS_GPGGA = Phidget22_C.PhidgetGPS_GPGGA()
			cstruct.latitude = Double(latitude)
			cstruct.longitude = Double(longitude)
			cstruct.fixQuality = Int16(fixQuality)
			cstruct.numSatellites = Int16(numSatellites)
			cstruct.horizontalDilution = Double(horizontalDilution)
			cstruct.altitude = Double(altitude)
			cstruct.heightOfGeoid = Double(heightOfGeoid)
			return cstruct
		}
	}
}
public struct GPGSA {
	public var mode: CChar
	public var fixType: Int16
	public var satUsed: [Int16]
	public var positionDilution: Double
	public var horizontalDilution: Double
	public var verticalDilution: Double

	public init(
		mode: CChar,
		fixType: Int16,
		satUsed: [Int16],
		positionDilution: Double,
		horizontalDilution: Double,
		verticalDilution: Double
	) {
		self.mode = mode
		self.fixType = fixType
		self.satUsed = satUsed
		self.positionDilution = positionDilution
		self.horizontalDilution = horizontalDilution
		self.verticalDilution = verticalDilution
	}

	internal init(_ cstruct: Phidget22_C.PhidgetGPS_GPGSA) {
		mode = cstruct.mode
		fixType = cstruct.fixType
		var satUsedTmp = cstruct.satUsed
		satUsed = [Int16](UnsafeBufferPointer(start: &satUsedTmp.0, count: 12))
		positionDilution = cstruct.posnDilution
		horizontalDilution = cstruct.horizDilution
		verticalDilution = cstruct.vertDilution
	}
	internal var cstruct: Phidget22_C.PhidgetGPS_GPGSA {
		get {
			var cstruct: Phidget22_C.PhidgetGPS_GPGSA = Phidget22_C.PhidgetGPS_GPGSA()
			cstruct.mode = CChar(mode)
			cstruct.fixType = Int16(fixType)
			precondition(satUsed.count <= 12, "satUsed array must have at most 12 elements")
			memcpy(&cstruct.satUsed, satUsed, satUsed.count * MemoryLayout<Int16>.size)
			cstruct.posnDilution = Double(positionDilution)
			cstruct.horizDilution = Double(horizontalDilution)
			cstruct.vertDilution = Double(verticalDilution)
			return cstruct
		}
	}
}
public struct GPRMC {
	public var status: CChar
	public var latitude: Double
	public var longitude: Double
	public var speedKnots: Double
	public var heading: Double
	public var magneticVariation: Double
	public var mode: CChar

	public init(
		status: CChar,
		latitude: Double,
		longitude: Double,
		speedKnots: Double,
		heading: Double,
		magneticVariation: Double,
		mode: CChar
	) {
		self.status = status
		self.latitude = latitude
		self.longitude = longitude
		self.speedKnots = speedKnots
		self.heading = heading
		self.magneticVariation = magneticVariation
		self.mode = mode
	}

	internal init(_ cstruct: Phidget22_C.PhidgetGPS_GPRMC) {
		status = cstruct.status
		latitude = cstruct.latitude
		longitude = cstruct.longitude
		speedKnots = cstruct.speedKnots
		heading = cstruct.heading
		magneticVariation = cstruct.magneticVariation
		mode = cstruct.mode
	}
	internal var cstruct: Phidget22_C.PhidgetGPS_GPRMC {
		get {
			var cstruct: Phidget22_C.PhidgetGPS_GPRMC = Phidget22_C.PhidgetGPS_GPRMC()
			cstruct.status = CChar(status)
			cstruct.latitude = Double(latitude)
			cstruct.longitude = Double(longitude)
			cstruct.speedKnots = Double(speedKnots)
			cstruct.heading = Double(heading)
			cstruct.magneticVariation = Double(magneticVariation)
			cstruct.mode = CChar(mode)
			return cstruct
		}
	}
}
public struct GPVTG {
	public var trueHeading: Double
	public var magneticHeading: Double
	public var speedKnots: Double
	public var speed: Double
	public var mode: CChar

	public init(
		trueHeading: Double,
		magneticHeading: Double,
		speedKnots: Double,
		speed: Double,
		mode: CChar
	) {
		self.trueHeading = trueHeading
		self.magneticHeading = magneticHeading
		self.speedKnots = speedKnots
		self.speed = speed
		self.mode = mode
	}

	internal init(_ cstruct: Phidget22_C.PhidgetGPS_GPVTG) {
		trueHeading = cstruct.trueHeading
		magneticHeading = cstruct.magneticHeading
		speedKnots = cstruct.speedKnots
		speed = cstruct.speed
		mode = cstruct.mode
	}
	internal var cstruct: Phidget22_C.PhidgetGPS_GPVTG {
		get {
			var cstruct: Phidget22_C.PhidgetGPS_GPVTG = Phidget22_C.PhidgetGPS_GPVTG()
			cstruct.trueHeading = Double(trueHeading)
			cstruct.magneticHeading = Double(magneticHeading)
			cstruct.speedKnots = Double(speedKnots)
			cstruct.speed = Double(speed)
			cstruct.mode = CChar(mode)
			return cstruct
		}
	}
}
public struct NMEAData {
	public var GGA: GPGGA
	public var GSA: GPGSA
	public var RMC: GPRMC
	public var VTG: GPVTG

	public init(
		GGA: GPGGA,
		GSA: GPGSA,
		RMC: GPRMC,
		VTG: GPVTG
	) {
		self.GGA = GGA
		self.GSA = GSA
		self.RMC = RMC
		self.VTG = VTG
	}

	internal init(_ cstruct: Phidget22_C.PhidgetGPS_NMEAData) {
		GGA = GPGGA(cstruct.GGA)
		GSA = GPGSA(cstruct.GSA)
		RMC = GPRMC(cstruct.RMC)
		VTG = GPVTG(cstruct.VTG)
	}
	internal var cstruct: Phidget22_C.PhidgetGPS_NMEAData {
		get {
			var cstruct: Phidget22_C.PhidgetGPS_NMEAData = Phidget22_C.PhidgetGPS_NMEAData()
			cstruct.GGA = GGA.cstruct
			cstruct.GSA = GSA.cstruct
			cstruct.RMC = RMC.cstruct
			cstruct.VTG = VTG.cstruct
			return cstruct
		}
	}
}
public enum HubPortMode: UInt32 {
	case VINT = 0
	case digitalInput = 1
	case digitalOutput = 2
	case voltageInput = 3
	case voltageRatioInput = 4
}
public enum IRCodeEncoding: UInt32 {
	case unknown = 1
	case space = 2
	case pulse = 3
	case biPhase = 4
	case RC5 = 5
	case RC6 = 6
}
public enum IRCodeLength: UInt32 {
	case unknown = 1
	case constant = 2
	case variable = 3
}
public struct IRCodeInfo {
	public var bitCount: UInt32
	public var encoding: IRCodeEncoding
	public var length: IRCodeLength
	public var gap: UInt32
	public var trail: UInt32
	public var header: [UInt32]
	public var one: [UInt32]
	public var zero: [UInt32]
	public var repeatCode: [UInt32]
	public var minRepeat: UInt32
	public var dutyCycle: Double
	public var carrierFrequency: UInt32
	public var toggleMask: String

	public init(
		bitCount: UInt32,
		encoding: IRCodeEncoding,
		length: IRCodeLength,
		gap: UInt32,
		trail: UInt32,
		header: [UInt32],
		one: [UInt32],
		zero: [UInt32],
		repeatCode: [UInt32],
		minRepeat: UInt32,
		dutyCycle: Double,
		carrierFrequency: UInt32,
		toggleMask: String
	) {
		self.bitCount = bitCount
		self.encoding = encoding
		self.length = length
		self.gap = gap
		self.trail = trail
		self.header = header
		self.one = one
		self.zero = zero
		self.repeatCode = repeatCode
		self.minRepeat = minRepeat
		self.dutyCycle = dutyCycle
		self.carrierFrequency = carrierFrequency
		self.toggleMask = toggleMask
	}

	internal init(_ cstruct: Phidget22_C.PhidgetIR_CodeInfo) {
		bitCount = cstruct.bitCount
		encoding = IRCodeEncoding(rawValue: cstruct.encoding.rawValue)!
		length = IRCodeLength(rawValue: cstruct.length.rawValue)!
		gap = cstruct.gap
		trail = cstruct.trail
		var headerTmp = cstruct.header
		header = [UInt32](UnsafeBufferPointer(start: &headerTmp.0, count: 2))
		var oneTmp = cstruct.one
		one = [UInt32](UnsafeBufferPointer(start: &oneTmp.0, count: 2))
		var zeroTmp = cstruct.zero
		zero = [UInt32](UnsafeBufferPointer(start: &zeroTmp.0, count: 2))
		var repeatCodeTmp = cstruct.repeat
		repeatCode = [UInt32](UnsafeBufferPointer(start: &repeatCodeTmp.0, count: 26))
		minRepeat = cstruct.minRepeat
		dutyCycle = cstruct.dutyCycle
		carrierFrequency = cstruct.carrierFrequency
		var toggleMaskTmp = cstruct.toggleMask
		toggleMask = String(cString: &toggleMaskTmp.0)
	}
	internal var cstruct: Phidget22_C.PhidgetIR_CodeInfo {
		get {
			var cstruct: Phidget22_C.PhidgetIR_CodeInfo = Phidget22_C.PhidgetIR_CodeInfo()
			cstruct.bitCount = UInt32(bitCount)
			cstruct.encoding = PhidgetIR_Encoding(encoding.rawValue)
			cstruct.length = PhidgetIR_Length(length.rawValue)
			cstruct.gap = UInt32(gap)
			cstruct.trail = UInt32(trail)
			precondition(header.count <= 2, "header array must have at most 2 elements")
			memcpy(&cstruct.header, header, header.count * MemoryLayout<UInt32>.size)
			precondition(one.count <= 2, "one array must have at most 2 elements")
			memcpy(&cstruct.one, one, one.count * MemoryLayout<UInt32>.size)
			precondition(zero.count <= 2, "zero array must have at most 2 elements")
			memcpy(&cstruct.zero, zero, zero.count * MemoryLayout<UInt32>.size)
			precondition(repeatCode.count <= 26, "repeatCode array must have at most 26 elements")
			memcpy(&cstruct.repeat, repeatCode, repeatCode.count * MemoryLayout<UInt32>.size)
			cstruct.minRepeat = UInt32(minRepeat)
			cstruct.dutyCycle = Double(dutyCycle)
			cstruct.carrierFrequency = UInt32(carrierFrequency)
			let toggleMaskTmp = Array(toggleMask.utf8)
			precondition(toggleMaskTmp.count <= 33, "toggleMask must have at most 33 characters")
			memcpy(&cstruct.toggleMask, toggleMaskTmp, toggleMaskTmp.count)
			return cstruct
		}
	}
}
public enum LCDFont: UInt32 {
	case user1 = 1
	case user2 = 2
	case dimensions_6x10 = 3
	case dimensions_5x8 = 4
	case dimensions_6x12 = 5
}
public enum LCDScreenSize: UInt32 {
	case noScreen = 1
	case dimensions_1x8 = 2
	case dimensions_2x8 = 3
	case dimensions_1x16 = 4
	case dimensions_2x16 = 5
	case dimensions_4x16 = 6
	case dimensions_2x20 = 7
	case dimensions_4x20 = 8
	case dimensions_2x24 = 9
	case dimensions_1x40 = 10
	case dimensions_2x40 = 11
	case dimensions_4x40 = 12
	case dimensions_64x128 = 13
}
public enum LCDPixelState: UInt32 {
	case off = 0
	case on = 1
	case invert = 2
}
public struct UnitInfo {
	public var unit: Unit
	public var name: String
	public var symbol: String

	public init(
		unit: Unit,
		name: String,
		symbol: String
	) {
		self.unit = unit
		self.name = name
		self.symbol = symbol
	}

	internal init(_ cstruct: Phidget22_C.Phidget_UnitInfo) {
		unit = Unit(rawValue: cstruct.unit.rawValue)!
		name = String(cString: cstruct.name!)
		symbol = String(cString: cstruct.symbol!)
	}
	internal var cstruct: Phidget22_C.Phidget_UnitInfo {
		get {
			var cstruct: Phidget22_C.Phidget_UnitInfo = Phidget22_C.Phidget_UnitInfo()
			cstruct.unit = Phidget_Unit(unit.rawValue)
			cstruct.name = UnsafePointer<CChar>(name.cString(using: .utf8))
			cstruct.symbol = UnsafePointer<CChar>(symbol.cString(using: .utf8))
			return cstruct
		}
	}
}
public enum ServerType: UInt32 {
	case deviceRemote = 3
	case WWWRemote = 6
	case SBC = 7
}
public struct PhidgetServer {
	public var name: String
	public var typeName: String
	public var type: ServerType
	public var flags: Int
	public var address: String
	public var hostname: String
	public var port: Int

	public init(
		name: String,
		typeName: String,
		type: ServerType,
		flags: Int,
		address: String,
		hostname: String,
		port: Int
	) {
		self.name = name
		self.typeName = typeName
		self.type = type
		self.flags = flags
		self.address = address
		self.hostname = hostname
		self.port = port
	}

	internal init(_ cstruct: Phidget22_C.PhidgetServer) {
		name = String(cString: cstruct.name!)
		typeName = String(cString: cstruct.stype!)
		type = ServerType(rawValue: cstruct.type.rawValue)!
		flags = Int(cstruct.flags)
		address = String(cString: cstruct.addr!)
		hostname = String(cString: cstruct.host!)
		port = Int(cstruct.port)
	}
	internal var cstruct: Phidget22_C.PhidgetServer {
		get {
			var cstruct: Phidget22_C.PhidgetServer = Phidget22_C.PhidgetServer()
			cstruct.name = UnsafePointer<CChar>(name.cString(using: .utf8))
			cstruct.stype = UnsafePointer<CChar>(typeName.cString(using: .utf8))
			cstruct.type = PhidgetServerType(type.rawValue)
			cstruct.flags = Int32(flags)
			cstruct.addr = UnsafePointer<CChar>(address.cString(using: .utf8))
			cstruct.host = UnsafePointer<CChar>(hostname.cString(using: .utf8))
			cstruct.port = Int32(port)
			return cstruct
		}
	}
}
public enum RCServoVoltage: UInt32 {
	case volts_5_0 = 1
	case volts_6_0 = 2
	case volts_7_4 = 3
}
public enum RFIDProtocol: UInt32 {
	case EM4100 = 1
	case ISO11785_FDX_B = 2
	case phidgetTAG = 3
}
public enum SPLRange: UInt32 {
	case dB_102 = 1
	case dB_82 = 2
}
public enum StepperControlMode: UInt32 {
	case step = 0
	case run = 1
}
public enum RTDType: UInt32 {
	case PT100_3850 = 1
	case PT1000_3850 = 2
	case PT100_3920 = 3
	case PT1000_3920 = 4
}
public enum ThermocoupleType: UInt32 {
	case J = 1
	case K = 2
	case E = 3
	case T = 4
}
public enum VoltageRange: UInt32 {
	case milliVolts_10 = 1
	case milliVolts_40 = 2
	case milliVolts_200 = 3
	case milliVolts_312_5 = 4
	case milliVolts_400 = 5
	case milliVolts_1000 = 6
	case volts_2 = 7
	case volts_5 = 8
	case volts_15 = 9
	case volts_40 = 10
	case auto = 11
}
public enum VoltageSensorType: UInt32 {
	case voltage = 0
	case PN_1114 = 11140
	case PN_1117 = 11170
	case PN_1123 = 11230
	case PN_1127 = 11270
	case PN_1130_pH = 11301
	case PN_1130_ORP = 11302
	case PN_1132 = 11320
	case PN_1133 = 11330
	case PN_1135 = 11350
	case PN_1142 = 11420
	case PN_1143 = 11430
	case PN_3500 = 35000
	case PN_3501 = 35010
	case PN_3502 = 35020
	case PN_3503 = 35030
	case PN_3507 = 35070
	case PN_3508 = 35080
	case PN_3509 = 35090
	case PN_3510 = 35100
	case PN_3511 = 35110
	case PN_3512 = 35120
	case PN_3513 = 35130
	case PN_3514 = 35140
	case PN_3515 = 35150
	case PN_3516 = 35160
	case PN_3517 = 35170
	case PN_3518 = 35180
	case PN_3519 = 35190
	case PN_3584 = 35840
	case PN_3585 = 35850
	case PN_3586 = 35860
	case PN_3587 = 35870
	case PN_3588 = 35880
	case PN_3589 = 35890
}
public enum VoltageOutputRange: UInt32 {
	case volts_10 = 1
	case volts_5 = 2
}
public enum BridgeGain: UInt32 {
	case gain_1x = 1
	case gain_2x = 2
	case gain_4x = 3
	case gain_8x = 4
	case gain_16x = 5
	case gain_32x = 6
	case gain_64x = 7
	case gain_128x = 8
}
public enum VoltageRatioSensorType: UInt32 {
	case voltageRatio = 0
	case PN_1101_Sharp2D120X = 11011
	case PN_1101_Sharp2Y0A21 = 11012
	case PN_1101_Sharp2Y0A02 = 11013
	case PN_1102 = 11020
	case PN_1103 = 11030
	case PN_1104 = 11040
	case PN_1105 = 11050
	case PN_1106 = 11060
	case PN_1107 = 11070
	case PN_1108 = 11080
	case PN_1109 = 11090
	case PN_1110 = 11100
	case PN_1111 = 11110
	case PN_1112 = 11120
	case PN_1113 = 11130
	case PN_1115 = 11150
	case PN_1116 = 11160
	case PN_1118_AC = 11181
	case PN_1118_DC = 11182
	case PN_1119_AC = 11191
	case PN_1119_DC = 11192
	case PN_1120 = 11200
	case PN_1121 = 11210
	case PN_1122_AC = 11221
	case PN_1122_DC = 11222
	case PN_1124 = 11240
	case PN_1125_Humidity = 11251
	case PN_1125_Temperature = 11252
	case PN_1126 = 11260
	case PN_1128 = 11280
	case PN_1129 = 11290
	case PN_1131 = 11310
	case PN_1134 = 11340
	case PN_1136 = 11360
	case PN_1137 = 11370
	case PN_1138 = 11380
	case PN_1139 = 11390
	case PN_1140 = 11400
	case PN_1141 = 11410
	case PN_1146 = 11460
	case PN_3120 = 31200
	case PN_3121 = 31210
	case PN_3122 = 31220
	case PN_3123 = 31230
	case PN_3130 = 31300
	case PN_3520 = 35200
	case PN_3521 = 35210
	case PN_3522 = 35220
}
